%{
#include "calc.h"
#include "y.tab.h"
#include <stdlib.h>
#include <math.h>
#undef YY_INPUT
#define YY_INPUT(tbuf, retval, maxlen) (retval=get_input(tbuf,maxlen))
%}
%%
[0-9]+					{ yylval.ival = atoi (yytext); return INTEGER;}
[1-9]*[0-9]+"."[0-9]+	{ yylval.fval = atof (yytext); return REAL;}
([abdf-orwxz])			{ yylval.ival = yytext[1] - 'a';  return VARIABLE;}
([Aa](ns|NS))			return ANS;
[ \t]					;

(pi|PI)					return PI;
(e|E)					return E;
(c|C)					return C;
(p|P)					return P;
(y|Y)					return Y;
[Ff](unc|UNC)			return FUNC;

[Ii](ntegral|NTEGRAL)	return INTEGRAL;
[Ii](nt|NT)				return INTEGRAL;
[Pp](rime|RIME)			return PRIME;
[Ff]\'					return PRIME;
[Tt](o|O)				return TO;



[Cc](eil|EIL)		return CEIL;
[Rr](int|INT)		return RINT;
[Ff](loor|LOOR)		return FLOOR;

[Ss](in|IN)			return SIN;
[Cc](os|OS)			return COS;
[Tt](an|AN)			return TAN;
[Ss](ec|EC)			return SEC;
[Cc](sc|SC)			return CSC;
[Cc](ot|OT)			return COT;
[Aa](sin|SIN)		return ASIN;
[Aa](cos|COS)		return ACOS;
[Aa](tan|TAN)		return ATAN;
[Ee](xp|XP)			return EXP;
[Ll](og|OG)			return LOG;
[Ll](n|N)			return LN;
[Ll](g|G)			return LG;

(max_x|MAX_X)		return MAX_X;
(min_x|MIN_X)		return MIN_X;
(sum_x|SUM_X)		return SUM_X;
(mean_x|MEAN_X)		return MEAN_X;
(var_x|VAR_X)		return VAR_X;


(max_y|MAX_Y)		return MAX_Y;
(min_y|MIN_Y)		return MIN_Y;
(sum_y|SUM_Y)		return SUM_Y;
(mean_y|MEAN_Y)		return MEAN_Y;
(var_y|VAR_Y)		return VAR_Y;

(help|HELP)			return HELP;
(show|SHOW)			return SHOW;
(clear|CLEAR)		return CLEAR;
(del|DEL)			return DEL;
(exit|EXIT|q|Q)		return EXIT;

(sqrt|SQRT)			return SQRT;
\n					|
.					return yytext[0];
%%

int get_input(char *tbuf, int maxlen){
	int n=strlen(pbuf);
	if(maxlen<n){
		n=maxlen;
	}
	if (n>0){
		memcpy(tbuf, pbuf, n);
		pbuf= pbuf+n;

	}
//	printf("in lex: %s", tbuf);
	return n;
}
